/**********************************************************************
  アドレス変換
  $Id: adtr.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int	adtr_func( struct MACHINE_RESOURCE *mres , int *pa, unsigned int ea )
{
  int          is_ifetch ;
  unsigned int mask ; 
  
  if( ea==0x8000ff00 ){ // for pseudo console
    *pa=ea ;
    __pa_for_exception=*pa ;
    return(NORMAL_EXIT) ;
  }
#ifdef SUPPORT_GRAPHIC_DEVICE
  if( seg(ea)==seg(GRAPHIC_VRAM_TOP) ){
    if( (__memaccess_mode & MEM_STORE)!=0 ){
      GdevBuf.buf[GdevBuf.c++]=ea ;
      if( (__memaccess_mode & MEM_8B)!=0 ){
		GdevBuf.buf[GdevBuf.c++]=ea+4 ;
      }
    }
    *pa=ea ;
    return(NORMAL_EXIT) ;
  }
#endif
  
  
  if( (__memaccess_mode & MEM_IACCESS)!=0 ) is_ifetch=8 ;
  else                                    { is_ifetch=0 ; SET_MEM_PROBE() ; }
  
  __access_fdc=0 ;
  if( (ea & 0xfffffff8)==0x800003f0 ){
    __access_fdc     = 1 ;
    __access_fdc_pc  =mres->pc ;
    __access_fdc_adrs=ea ;
    __access_fdc_is_ld= ((__memaccess_mode & MEM_FETCH)!=0) ? 1 : 0 ;
  }
  
  if( ( is_ifetch==0 && (*mres->MSR & 0x00000010)!=0 ) ||
      ( is_ifetch!=0 && (*mres->MSR & 0x00000020)!=0 ) ){
	
    /** Check BAT adrs translation **/
	
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[536-is_ifetch] & 0x00000002)!=0) || 
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[536-is_ifetch] & 0x00000001)!=0) ){
      mask = 0xf0000000 | ( ~((*mres->SPR[536-is_ifetch] & 0x00001ffc) << 15) & 0x0ffe0000 ) ;
      if( (*mres->SPR[536-is_ifetch] & mask)==(ea & mask) ){
		*pa=(*mres->SPR[537-is_ifetch] & mask) | (ea & (~mask & 0x0ffe0000)) | (ea & 0x0001ffff) ;
		__ea_for_exception=ea  ;
		__pa_for_exception=*pa ;
		return(NORMAL_EXIT) ;
      }
    }
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[538-is_ifetch] & 0x00000002)!=0) ||
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[538-is_ifetch] & 0x00000001)!=0) ){
      mask = 0xf0000000 | ( ~((*mres->SPR[538-is_ifetch] & 0x00001ffc) << 15) & 0x0ffe0000 ) ;
      if( (*mres->SPR[538-is_ifetch] & mask)==(ea & mask) ){
		*pa=(*mres->SPR[539-is_ifetch] & mask) | (ea & (~mask & 0x0ffe0000)) | (ea & 0x0001ffff) ;
		__ea_for_exception=ea  ;
		__pa_for_exception=*pa ;
		return(NORMAL_EXIT) ;
      }
    }
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[540-is_ifetch] & 0x00000002)!=0) ||
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[540-is_ifetch] & 0x00000001)!=0) ){
      mask = 0xf0000000 | ( ~((*mres->SPR[540-is_ifetch] & 0x00001ffc) << 15) & 0x0ffe0000 ) ;
      if( (*mres->SPR[540-is_ifetch] & mask)==(ea & mask) ){
		*pa=(*mres->SPR[541-is_ifetch] & mask) | (ea & (~mask & 0x0ffe0000)) | (ea & 0x0001ffff) ;
		__ea_for_exception=ea  ;
		__pa_for_exception=*pa ;
		return(NORMAL_EXIT) ;
      }
    }
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[542-is_ifetch] & 0x00000002)!=0) ||
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[542-is_ifetch] & 0x00000001)!=0) ){
      mask = 0xf0000000 | ( ~((*mres->SPR[542-is_ifetch] & 0x00001ffc) << 15) & 0x0ffe0000 ) ;
      if( (*mres->SPR[542-is_ifetch] & mask)==(ea & mask) ){
		*pa=(*mres->SPR[543-is_ifetch] & mask) | (ea & (~mask & 0x0ffe0000)) | (ea & 0x0001ffff) ;
		__ea_for_exception=ea  ;
		__pa_for_exception=*pa ;
		return(NORMAL_EXIT) ;
      }
    }
	
    /*** Check page adrs translation **/
    {
      unsigned int byte_offset ;
      unsigned int vsid ;
      unsigned int page_index ;
      unsigned int htaborg ;
      unsigned int htabmask ;
      unsigned int hashval1 ;
      unsigned int hashval2 ;
      unsigned int primPTEad ;
      unsigned int secondPTEad ;
      unsigned int pte_u ;
      unsigned int pte_l ;
      int i ;
	  
      byte_offset = ea & 0x00000fff ;
      vsid        = *mres->SR[((ea & 0xf0000000)>>28)] & 0x00ffffff ;
      page_index  = (ea & 0x0ffff000)>>12 ;
      htaborg     = (*mres->SPR[25] & 0xffff0000)>>16 ;
      htabmask    = (*mres->SPR[25] & 0x000001ff) ;
      hashval1    = (vsid & 0x0007fff) ^ page_index ;
      primPTEad   = ((htaborg & ~(htabmask))<<16) | (((hashval1>>10) & htabmask)<<16) | ((hashval1 & 0x000003ff)<<6) ;
      hashval2    = ~(hashval1) ;
      secondPTEad = ((htaborg & ~(htabmask))<<16) | (((hashval2>>10) & htabmask)<<16) | ((hashval2 & 0x000003ff)<<6) ;
	  
      /*** primary hash PTE search ***/
      if( mres->mem[seg(primPTEad)]==NULL ) return(NON_PHYMEM) ;
      for( i=0 ; i<8 ; i++ ){
		pte_u = mres->mem[seg(primPTEad+0+i*8)][lad(primPTEad+0+i*8)]<<24 | \
		  mres->mem[seg(primPTEad+1+i*8)][lad(primPTEad+1+i*8)]<<16 | \
		  mres->mem[seg(primPTEad+2+i*8)][lad(primPTEad+2+i*8)]<<8  | \
		  mres->mem[seg(primPTEad+3+i*8)][lad(primPTEad+3+i*8)] ;
		if( (pte_u & 0x80000040)==0x80000000 && \
			((pte_u & 0x7fff8000)>>15)==vsid && \
			((pte_u & 0x0000003f) == (page_index >> 10)) ) {
		  pte_l = mres->mem[seg(primPTEad+4+i*8)][lad(primPTEad+4+i*8)]<<24 | \
			mres->mem[seg(primPTEad+5+i*8)][lad(primPTEad+5+i*8)]<<16 | \
			mres->mem[seg(primPTEad+6+i*8)][lad(primPTEad+6+i*8)]<<8  | \
			mres->mem[seg(primPTEad+7+i*8)][lad(primPTEad+7+i*8)] ;
		  *pa = (pte_l & 0xfffff000) | byte_offset ;
		  SYSMSG("ea=%08x   pa=%08x\n",ea,*pa) ;
		  __ea_for_exception=ea  ;
		  __pa_for_exception=*pa ;
		  return(NORMAL_EXIT) ;
		}
      }
      /*** secondary hash PTE search ***/
      if( mres->mem[seg(secondPTEad)]==NULL ) return(NON_PHYMEM) ;
      for( i=0 ; i<8 ; i++ ){
		pte_u = mres->mem[seg(secondPTEad+0+i*8)][lad(secondPTEad+0+i*8)]<<24 | \
		  mres->mem[seg(secondPTEad+1+i*8)][lad(secondPTEad+1+i*8)]<<16 | \
		  mres->mem[seg(secondPTEad+2+i*8)][lad(secondPTEad+2+i*8)]<<8  | \
		  mres->mem[seg(secondPTEad+3+i*8)][lad(secondPTEad+3+i*8)] ;
		if( (pte_u & 0x80000040)==0x80000000 && \
			((pte_u & 0x7fff8000)>>15)==vsid && \
			((pte_u & 0x0000003f) == (page_index >> 10)) ) {
		  pte_l = mres->mem[seg(secondPTEad+4+i*8)][lad(secondPTEad+4+i*8)]<<24 | \
			mres->mem[seg(secondPTEad+5+i*8)][lad(secondPTEad+5+i*8)]<<16 | \
			mres->mem[seg(secondPTEad+6+i*8)][lad(secondPTEad+6+i*8)]<<8  | \
			mres->mem[seg(secondPTEad+7+i*8)][lad(secondPTEad+7+i*8)] ;
		  *pa = (pte_l & 0xfffff000) | byte_offset ;
		  SYSMSG("ea=%08x   pa=%08x\n",ea,*pa) ;
		  __ea_for_exception=ea  ;
		  __pa_for_exception=*pa ;
		  return(NORMAL_EXIT) ;
		}
      }
      DEBUGMSG("byte_offset=%08x\n",byte_offset) ;
      DEBUGMSG("vsid=%08x\n",vsid) ;
      DEBUGMSG("page_index=%08x\n",page_index) ;
      DEBUGMSG("htaborg=%08x\n",htaborg) ;
      DEBUGMSG("htabmask=%08x\n",htabmask) ;
      DEBUGMSG("hashval1=%08x\n",hashval1) ;
      DEBUGMSG("primPTEad=%08x\n",primPTEad) ;
      DEBUGMSG("hashval2=%08x\n",hashval2) ;
      DEBUGMSG("secondPTEad=%08x\n",secondPTEad) ;
    }
	
    __ea_for_exception=ea  ;
    __pa_for_exception=*pa ;
    return(MEM_AREA_OVER) ;    
  }else{
    *pa=ea ;
    __ea_for_exception=ea  ;
    __pa_for_exception=*pa ;
    return(NORMAL_EXIT) ;
  }
}

