/**********************************************************************
  sim VRAM (Pseudo Video RAM )
  $Id: dev_vram.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int dev_vram( unsigned int port , struct MACHINE_RESOURCE *mres )
{

#ifdef SUPPORT_GRAPHIC_DEVICE
  int cmd ;
  
  cmd = mres->mem[seg(port+3)][lad(port+3)] ;
  if( cmd!=0 ) SyncGdevDraw( mres ) ;
#endif

  return( NORMAL_EXIT ) ;
}


int dev_vram_init( struct MACHINE_RESOURCE *mres )
{
#ifdef SUPPORT_GRAPHIC_DEVICE
  gdev_vp=opengdev(GRAPHIC_VRAM_WIDTH, GRAPHIC_VRAM_HEIGHT,
		   GRAPHIC_SCREEN_WIDTH, GRAPHIC_SCREEN_HEIGHT,
		   GRAPHIC_NAME) ;
  GdevBuf.n=GdevAccessBufSize ;
  GdevRefRate=DEFAULT_GDEVREFRATE ;
  GdevBuf.c=0 ;
  GdevBuf.buf=malloc(sizeof(unsigned int)*(GdevBuf.n+1)) ;
#endif
  
  return( NORMAL_EXIT ) ;
}  


#ifdef SUPPORT_GRAPHIC_DEVICE
void actionfunc(int c)
{
    switch (c){
    default:
        return;
    }
}

void SyncGdevDraw(struct MACHINE_RESOURCE *mres)
{
  int x,y,i ;
  unsigned int ad,old_ad,vp_ad ;
  
  ad=0; old_ad=0;
  for( i=0 ; i<GdevBuf.c ; i++ ){
    ad=GdevBuf.buf[i]/GRAPHIC_VRAM_DEPTH ;
    if( ad==old_ad ) continue ;
    x=(ad & (~GRAPHIC_VRAM_TOP/GRAPHIC_VRAM_DEPTH)) % GRAPHIC_VRAM_WIDTH ;
    if( x>=GRAPHIC_SCREEN_WIDTH  ) continue ;
    y=(ad & (~GRAPHIC_VRAM_TOP/GRAPHIC_VRAM_DEPTH)) / GRAPHIC_VRAM_WIDTH ;
    if( y>=GRAPHIC_SCREEN_HEIGHT ) continue ;
    old_ad=ad ;
    ad=ad*GRAPHIC_VRAM_DEPTH ;
    vp_ad=y*GRAPHIC_VRAM_WIDTH+x ;
    gdev_vp[vp_ad].r=mres->mem[seg(ad+1)][lad(ad+1)] ;
    gdev_vp[vp_ad].g=mres->mem[seg(ad+2)][lad(ad+2)] ;
    gdev_vp[vp_ad].b=mres->mem[seg(ad+3)][lad(ad+3)] ;
  }
  GdevBuf.c=0 ;
}
#endif
