/**********************************************************************
  実行コマンド
  $Id: kill_cmd.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int  kill_parse_opt(struct GETOPT_ARG *args) ;
void kill_print_help() ;

int kill_cmd( struct GETOPT_ARG *args , int mode )
{
  int id ;
  int ret ;
  
  ret=kill_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  id=proc_list.cur_id ;
  if( id==0 ){
    SYSMSG("Can not kill root process\n") ;
    return(NORMAL_EXIT) ;
  }
  remove_proc( &proc_list ) ;
  return(NORMAL_EXIT) ;
  
}


int kill_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      kill_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void kill_print_help()
{
  SYSERR(
	 "kill current proccess\n"
	 "Usage: kill [Options]\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     カレントプロセスを終了します。制御は親プロセスのfork()実行直後の命令で\n"
	 "    停止した状態になります。\n"
	 "     ID=0のルートプロセスはkillすることはできません。\n"
	 ) ;
}
