/**********************************************************************
  命令デコード  bit0-5=0b01xxxx
  $Id: op_13_subfunc.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
/*
mcrf         0 1 0 0 1 1 >crD< 0 0 >crS< 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
rfi(*2,*3)   0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 0 0
isync        0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 1 1 0 0
bclrx        0 1 0 0 1 1 > BO    < > BI    < 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 L
bcctrx       0 1 0 0 1 1 > BO    < > BI    < 0 0 0 0 0 1 0 0 0 0 1 0 0 0 0 L
crnor        0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 0 0 0 1 0 0 0 0 1 0
crandc       0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 0 1 0 0 0 0 0 0 1 0
crxor        0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 0 1 1 0 0 0 0 0 1 0
crnand       0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 0 1 1 1 0 0 0 0 1 0
crand        0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 1 0 0 0 0 0 0 0 1 0
creqv        0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 1 0 0 1 0 0 0 0 1 0
crorc        0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 1 1 0 1 0 0 0 0 1 0
cror         0 1 0 0 1 1 >crbD   < >crbA   < >crbB   < 0 1 1 1 0 0 0 0 0 1 0
*/

int op_13_000_func( struct MACHINE_RESOURCE *mres, int mode )  /* mcrf */
{
  int crfd,crfs ;
  
  crfd=(mres->inst & 0x03800000)>>23 ;
  crfs=(mres->inst & 0x001c0000)>>18 ;

  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%crf%d, %%crf%d\n",crfd,crfs) ;
  }

  if( DO_EXEC_INST(mode) ){
    mres->FLGR.cr[crfd]=mres->FLGR.cr[crfs] ;

    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_010_func( struct MACHINE_RESOURCE *mres, int mode )  /* bclrx */
{
  unsigned int	bi,bo,lk ;
  int          cc ;
  int          branch ;
  
  branch = NO ;
  lk  = mres->inst & 0x00000001 ;
  bo  =(mres->inst & 0x03e00000)<<6  ;
  bi  =(mres->inst & 0x001f0000)>>16 ;
  cc  = mres->FLGR.cr[(bi/4)] & (0x80000000>>(bi%4)) ;

  if( DO_EXEC_DIS(mode) ){
    if( lk != 0 ){
      SYSMSG("l") ;
    }
    SYSMSG("\t%d,%d\n",bo>>27,bi) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    switch( (bo & 0xf0000000) ){
    case 0x00000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl!=0 && cc==0 ) branch=YES ;
      break ;
    case 0x10000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl==0 && cc==0 ) branch=YES ;
      break ;
    case 0x20000000 :
      if( cc==0 ) branch=YES ;
      break ;
    case 0x40000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl!=0 && cc!=0 ) branch=YES ;
      break ;
    case 0x50000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl==0 && cc!=0 ) branch=YES ;
      break ;
    case 0x60000000 :
      if( cc!=0 ) branch=YES ;
      break ;
    case 0x80000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl!=0 ) branch=YES ;
      break ;
    case 0x90000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl==0 ) branch=YES ;
      break ;
    case 0xa0000000 :
      branch=YES ;
      break ;
    default :
      return(INVALID_BO) ;
    }
    if( branch==YES ){
      if( lk!=0 ){
	unsigned int next_lr ;
	next_lr=mres->pc+4 ;
	mres->pc=mres->FLGR.lrl ;
	mres->FLGR.lrl=next_lr ;
      }else{
	mres->pc=mres->FLGR.lrl ;
      }
    }else{
      mres->pc += 4 ;
    }
  }
  
  return(0) ;
}


int op_13_021_func( struct MACHINE_RESOURCE *mres, int mode )  /* crnor */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = ~(a | b) ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_032_func( struct MACHINE_RESOURCE *mres, int mode )  /* rfi */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\n") ;
  }

  if( DO_EXEC_INST(mode) ){
    mres->pc   = *mres->SPR[26] & 0xfffffffc ; /** SRR0 **/
    *mres->MSR = (*mres->MSR & ~(0x0000ff73)) | (*mres->SPR[27] & 0x0000ff73) ; /** SRR1 **/
  }
  
  return(0) ;
}


int op_13_081_func( struct MACHINE_RESOURCE *mres, int mode )  /* crandc */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
  
    d = a & ~b ;
  
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
  
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_096_func( struct MACHINE_RESOURCE *mres, int mode )  /* isync */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_13_0c1_func( struct MACHINE_RESOURCE *mres, int mode )  /* crxor */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = a ^ b ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_0e1_func( struct MACHINE_RESOURCE *mres, int mode )  /* crnand */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = ~(a & b) ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_101_func( struct MACHINE_RESOURCE *mres, int mode )  /* crand */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = a & b ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_121_func( struct MACHINE_RESOURCE *mres, int mode )  /* creqv */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = ~(a ^ b) ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_1a1_func( struct MACHINE_RESOURCE *mres, int mode )  /* crorc */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = a | ~b ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_1c1_func( struct MACHINE_RESOURCE *mres, int mode )  /* cror */
{
  unsigned int	crbd,crba,crbb ;
  unsigned int a,d,b ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  crba=(mres->inst & 0x001f0000)>>16 ;
  crbb=(mres->inst & 0x0000f800)>>11 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crbcrbcrb(crbd,crba,crbb) ;
  }

  if( DO_EXEC_INST(mode) ){
    a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
    b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
    
    d = a | b ;
    
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //リセットして
    mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //セットする
    
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_13_210_func( struct MACHINE_RESOURCE *mres, int mode )  /* bcctrx */
{
  unsigned int bi,bo,lk ;
  int          cc ;
  int          branch ;
  
  branch = NO ;
  lk  = mres->inst & 0x00000001 ;
  bo  =(mres->inst & 0x03e00000)<<6  ;
  bi  =(mres->inst & 0x001f0000)>>16 ;
  cc  = mres->FLGR.cr[(bi/4)] & (0x80000000>>(bi%4)) ;

  if( DO_EXEC_DIS(mode) ){
    if( lk != 0 ){
      SYSMSG("l") ;
    }
    SYSMSG("\t%d,%d\n",bo>>27,bi) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    switch( (bo & 0xf0000000) ){
    case 0x20000000 :
      if( cc==0 ) branch=YES ;
      break ;
    case 0x60000000 :
      if( cc!=0 ) branch=YES ;
      break ;
    case 0xa0000000 :
      branch=YES ;
      break ;
    default :
      return(INVALID_BO) ;
    }
    if( branch==YES ){
      if( lk!=0 ){
	mres->FLGR.lrl=mres->pc+4 ;
	mres->pc=mres->FLGR.ctrl ;
      }else{
	mres->pc=mres->FLGR.ctrl ;
      }
    }else{
      mres->pc += 4 ;
    }
  }
  
  return(0) ;
}
