/**********************************************************************
  命令デコード  bit0-5=0b01xxxx
  $Id: op_1f_subfunc.c 79 2011-12-03 15:34:56Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

/*cmp          0 1 1 1 1 1 >crD< 0 L > A     < > B     < 0 0 0 0 0 0 0 0 0 0 0*/
/*tw           0 1 1 1 1 1 > TO    < > A     < > B     < 0 0 0 0 0 0 0 1 0 0 0*/
/*subfcx       0 1 1 1 1 1 > D     < > A     < > B     < o 0 0 0 0 0 1 0 0 0 R*/
/*addcx        0 1 1 1 1 1 > D     < > A     < > B     < o 0 0 0 0 0 1 0 1 0 R*/
/*mulhwux      0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 0 0 1 0 1 1 R*/
/*mfcr         0 1 1 1 1 1 > D     < 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0*/
/*lwarx        0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 0 1 0 1 0 0 0*/
/*lwzx         0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 0 1 0 1 1 1 0*/
/*slwx         0 1 1 1 1 1 > S     < > A     < > B     < 0 0 0 0 0 1 1 0 0 0 R*/
/*cntlzwx      0 1 1 1 1 1 > S     < > A     < 0 0 0 0 0 0 0 0 0 0 1 1 0 1 0 R*/
/*andx         0 1 1 1 1 1 > S     < > A     < > B     < 0 0 0 0 0 1 1 1 0 0 R*/
/*cmpl         0 1 1 1 1 1 >crD< 0 L > A     < > B     < 0 0 0 0 1 0 0 0 0 0 0*/
/*subfx        0 1 1 1 1 1 > D     < > A     < > B     < o 0 0 0 1 0 1 0 0 0 R*/
/*dcbst        0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 0 0 0 0 1 1 0 1 1 0 0*/
/*lwzux        0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 1 1 0 1 1 1 0*/
/*andcx        0 1 1 1 1 1 > S     < > A     < > B     < 0 0 0 0 1 1 1 1 0 0 R*/
/*mulhwx       0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 1 0 0 1 0 1 1 R*/
/*mtsrd(*2,*3) 0 1 1 1 1 1 > S     < 0 > SR  < 0 0 0 0 0 0 0 0 1 0 1 0 0 1 0 0*/
/*mfmsr(*2)    0 1 1 1 1 1 > D     < 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 0 1 1 0*/
/*dcbf         0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 0 0 0 1 0 1 0 1 1 0 0*/
/*lbzx         0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 1 0 1 0 1 1 1 0*/
/*negx         0 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 O 0 0 1 1 0 1 0 0 0 R*/
/*mtsrdin(*23) 0 1 1 1 1 1 > S     < 0 0 0 0 0 > B     < 0 0 0 1 1 1 0 0 1 0 0*/
/*lbzux        0 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 1 1 1 0 1 1 1 0*/
/*norx         0 1 1 1 1 1 > S     < > A     < > B     < 0 0 0 1 1 1 1 1 0 0 R*/
/*subfex       0 1 1 1 1 1 > D     < > A     < > B     < o 0 1 0 0 0 1 0 0 0 R*/
/*addex        0 1 1 1 1 1 > D     < > A     < > B     < o 0 1 0 0 0 1 0 1 0 R*/
/*mtcrf        0 1 1 1 1 1 > S     < 0 > CRM         < 0 0 0 1 0 0 1 0 0 0 0 0*/
/*mtmsr(*2,*3) 0 1 1 1 1 1 > S     < 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 0 1 0 0*/
/*stwcx.       0 1 1 1 1 1 > S     < > A     < > B     < 0 0 1 0 0 1 0 1 1 0 1*/
/*stwx         0 1 1 1 1 1 > S     < > A     < > B     < 0 0 1 0 0 1 0 1 1 1 0*/
/*stwux        0 1 1 1 1 1 > S     < > A     < > B     < 0 0 1 0 1 1 0 1 1 1 0*/
/*subfzex      0 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 o 0 1 1 0 0 1 0 0 0 R*/
/*addzex       0 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 o 0 1 1 0 0 1 0 1 0 R*/
/*mtsr(*2,*3)  0 1 1 1 1 1 > S     < 0 > SR  < 0 0 0 0 0 0 0 1 1 0 1 0 0 1 0 0*/
/*stbx         0 1 1 1 1 1 > S     < > A     < > B     < 0 0 1 1 0 1 0 1 1 1 0*/
/*subfmex      0 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 o 0 1 1 1 0 1 0 0 0 R*/
/*addmex       0 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 o 0 1 1 1 0 1 0 1 0 R*/
/*mullwx       0 1 1 1 1 1 > D     < > A     < > B     < o 0 1 1 1 0 1 0 1 1 R*/
/*mtsrin(*2,3) 0 1 1 1 1 1 > S     < 0 0 0 0 0 > B     < 0 0 1 1 1 1 0 0 1 0 0*/
/*dcbtst       0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 0 0 1 1 1 1 0 1 1 0 0*/
/*stbux        0 1 1 1 1 1 > S     < > A     < > B     < 0 0 1 1 1 1 0 1 1 1 0*/
/*addx         0 1 1 1 1 1 > D     < > A     < > B     < o 1 0 0 0 0 1 0 1 0 R*/
/*dcbt         0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 0 1 0 0 0 1 0 1 1 0 0*/
/*lhzx         0 1 1 1 1 1 > D     < > A     < > B     < 0 1 0 0 0 1 0 1 1 1 0*/
/*eqvx         0 1 1 1 1 1 > S     < > A     < > B     < 0 1 0 0 0 1 1 1 0 0 R*/
/*tlbie(*2,4)  0 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 > B     < 0 1 0 0 1 1 0 0 1 0 0*/
/*eciwx        0 1 1 1 1 1 > D     < > A     < > B     < 0 1 0 0 1 1 0 1 1 0 0*/
/*lhzux        0 1 1 1 1 1 > D     < > A     < > B     < 0 1 0 0 1 1 0 1 1 1 0*/
/*xorx         0 1 1 1 1 1 > S     < > A     < > B     < 0 1 0 0 1 1 1 1 0 0 R*/
/*mfspr(*5)    0 1 1 1 1 1 > D     < > spr             < 0 1 0 1 0 1 0 0 1 1 0*/
/*lhax         0 1 1 1 1 1 > D     < > A     < > B     < 0 1 0 1 0 1 0 1 1 1 0*/
/*tlbia(2,4,7) 0 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 1 1 0 0 1 0 0*/
/*mftb         0 1 1 1 1 1 > D     < > tbr             < 0 1 0 1 1 1 0 0 1 1 0*/
/*lhaux        0 1 1 1 1 1 > D     < > A     < > B     < 0 1 0 1 1 1 0 1 1 1 0*/
/*sthx         0 1 1 1 1 1 > S     < > A     < > B     < 0 1 1 0 0 1 0 1 1 1 0*/
/*orcx         0 1 1 1 1 1 > S     < > A     < > B     < 0 1 1 0 0 1 1 1 0 0 R*/
/*ecowx        0 1 1 1 1 1 > S     < > A     < > B     < 0 1 1 0 1 1 0 1 1 0 0*/
/*sthux        0 1 1 1 1 1 > S     < > A     < > B     < 0 1 1 0 1 1 0 1 1 1 0*/
/*orx          0 1 1 1 1 1 > S     < > A     < > B     < 0 1 1 0 1 1 1 1 0 0 R*/
/*divwux       0 1 1 1 1 1 > D     < > A     < > B     < o 1 1 1 0 0 1 0 1 1 R*/
/*mtspr(*5)    0 1 1 1 1 1 > S     < > spr             < 0 1 1 1 0 1 0 0 1 1 0*/
/*dcbi(*2)     0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 0 1 1 1 0 1 0 1 1 0 0*/
/*nandx        0 1 1 1 1 1 > S     < > A     < > B     < 0 1 1 1 0 1 1 1 0 0 R*/
/*divwx        0 1 1 1 1 1 > D     < > A     < > B     < o 1 1 1 1 0 1 0 1 1 R*/
/*mcrxr        0 1 1 1 1 1 >crD< 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0*/
/*subfcx       0 1 1 1 1 1 > D     < > A     < > B     < o 0 0 0 0 0 1 0 0 0 R*/
/*addcx        0 1 1 1 1 1 > D     < > A     < > B     < o 0 0 0 0 0 1 0 1 0 R*/
/*lswx(*6)     0 1 1 1 1 1 > D     < > A     < > B     < 1 0 0 0 0 1 0 1 0 1 0*/
/*lwbrx        0 1 1 1 1 1 > D     < > A     < > B     < 1 0 0 0 0 1 0 1 1 0 0*/
/*lfsx         0 1 1 1 1 1 > D     < > A     < > B     < 1 0 0 0 0 1 0 1 1 1 0*/
/*srwx         0 1 1 1 1 1 > S     < > A     < > B     < 1 0 0 0 0 1 1 0 0 0 R*/
/*subfx        0 1 1 1 1 1 > D     < > A     < > B     < o 0 0 0 1 0 1 0 0 0 R*/
/*tlbsync(2,4) 0 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 0 1 1 0 0*/
/*lfsux        0 1 1 1 1 1 > D     < > A     < > B     < 1 0 0 0 1 1 0 1 1 1 0*/
/*mfsr(2,3)    0 1 1 1 1 1 > D     < 0 > SR  < 0 0 0 0 0 1 0 0 1 0 1 0 0 1 1 0*/
/*lswi(*6)     0 1 1 1 1 1 > D     < > A     < > NB    < 1 0 0 1 0 1 0 1 0 1 0*/
/*sync         0 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 1 0 1 1 0 0*/
/*lfdx         0 1 1 1 1 1 > D     < > A     < > B     < 1 0 0 1 0 1 0 1 1 1 0*/
/*negx         0 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 O 0 0 1 1 0 1 0 0 0 R*/
/*lfdux        0 1 1 1 1 1 > D     < > A     < > B     < 1 0 0 1 1 1 0 1 1 1 0*/
/*subfex       0 1 1 1 1 1 > D     < > A     < > B     < o 0 1 0 0 0 1 0 0 0 R*/
/*addex        0 1 1 1 1 1 > D     < > A     < > B     < o 0 1 0 0 0 1 0 1 0 R*/
/*mfsrin(2,3)  0 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 1 0 1 0 0 1 0 0 1 1 0*/
/*stswx(*6)    0 1 1 1 1 1 > S     < > A     < > B     < 1 0 1 0 0 1 0 1 0 1 0*/
/*stwbrx       0 1 1 1 1 1 > S     < > A     < > B     < 1 0 1 0 0 1 0 1 1 0 0*/
/*stfsx        0 1 1 1 1 1 > S     < > A     < > B     < 1 0 1 0 0 1 0 1 1 1 0*/
/*stfsux       0 1 1 1 1 1 > S     < > A     < > B     < 1 0 1 0 1 1 0 1 1 1 0*/
/*stswi(*6)    0 1 1 1 1 1 > S     < > A     < > NB    < 1 0 1 1 0 1 0 1 0 1 0*/
/*stfdx        0 1 1 1 1 1 > S     < > A     < > B     < 1 0 1 1 0 1 0 1 1 1 0*/
/*mullwx       0 1 1 1 1 1 > D     < > A     < > B     < o 0 1 1 1 0 1 0 1 1 R*/
/*dcba(*4,7)   0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 1 0 1 1 1 1 0 1 1 0 0*/
/*stfdux       0 1 1 1 1 1 > S     < > A     < > B     < 1 0 1 1 1 1 0 1 1 1 0*/
/*addx         0 1 1 1 1 1 > D     < > A     < > B     < o 1 0 0 0 0 1 0 1 0 R*/
/*lhbrx        0 1 1 1 1 1 > D     < > A     < > B     < 1 1 0 0 0 1 0 1 1 0 0*/
/*srawx        0 1 1 1 1 1 > S     < > A     < > B     < 1 1 0 0 0 1 1 0 0 0 R*/
/*srawix       0 1 1 1 1 1 > S     < > A     < > SH    < 1 1 0 0 1 1 1 0 0 0 R*/
/*eieio        0 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 0 1 0 1 1 0 0*/
/*sthbrx       0 1 1 1 1 1 > S     < > A     < > B     < 1 1 1 0 0 1 0 1 1 0 0*/
/*extshx       0 1 1 1 1 1 > S     < > A     < 0 0 0 0 0 1 1 1 0 0 1 1 0 1 0 R*/
/*extsbx       0 1 1 1 1 1 > S     < > A     < 0 0 0 0 0 1 1 1 0 1 1 1 0 1 0 R*/
/*divwux       0 1 1 1 1 1 > D     < > A     < > B     < o 1 1 1 0 0 1 0 1 1 R*/
/*icbi         0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 1 1 1 1 0 1 0 1 1 0 0*/
/*stfiwx(*4)   0 1 1 1 1 1 > S     < > A     < > B     < 1 1 1 1 0 1 0 1 1 1 0*/
/*divwx        0 1 1 1 1 1 > D     < > A     < > B     < o 1 1 1 1 0 1 0 1 1 R*/
/*dcbz         0 1 1 1 1 1 0 0 0 0 0 > A     < > B     < 1 1 1 1 1 1 0 1 1 0 0*/

int op_1f_000_func( struct MACHINE_RESOURCE *mres , int mode )  /* cmp */
{
  unsigned int r2,r3 ;
  unsigned int cr ;
  
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  cr = (mres->inst & 0x03800000)>>23 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crrr(cr,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( (int)mres->GPR[r2].rl == (int)mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x20000000 ;
    else                                                 mres->FLGR.cr[cr] &=~0x20000000 ;
    if( (int)mres->GPR[r2].rl >  (int)mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x40000000 ;
    else                                                 mres->FLGR.cr[cr] &=~0x40000000 ;
    if( (int)mres->GPR[r2].rl <  (int)mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x80000000 ;
    else                                                 mres->FLGR.cr[cr] &=~0x80000000 ;
    if( (mres->FLGR.xer & 0x80000000)!=0 )               mres->FLGR.cr[cr] |= 0x10000000 ;
    else                                                 mres->FLGR.cr[cr] &=~0x10000000 ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_004_func( struct MACHINE_RESOURCE *mres , int mode )  /* tw */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  unsigned int	r3 ;
  
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  r3   = (mres->inst & 0x0000f800)>>11 ;

  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%d, %%r%d, %%r%d\n",r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( ((r1 & 0x10)!=0 && (mres->GPR[r2].rl< (int)mres->GPR[r3].rl)) ||
	((r1 & 0x08)!=0 && (mres->GPR[r2].rl> (int)mres->GPR[r3].rl)) ||
	((r1 & 0x04)!=0 && (mres->GPR[r2].rl==mres->GPR[r3].rl)) ||
	((r1 & 0x02)!=0 && (mres->GPR[r2].rl> mres->GPR[r3].rl)) ||
	((r1 & 0x01)!=0 && (mres->GPR[r2].rl< mres->GPR[r3].rl)) )
      return( EXCEPTION_PROGRAM ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_008_func( struct MACHINE_RESOURCE *mres , int mode ) /* subfcx */
{
  unsigned int r1,r2,r3 ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	    (mres->GPR[r3].rl & 0x00000001)+1)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ~mres->GPR[r2].rl + mres->GPR[r3].rl + 1  ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}   
  

int op_1f_00a_func( struct MACHINE_RESOURCE *mres , int mode ) /* addcx */
{
  unsigned int r1,r2,r3 ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    bit32c=0 ;
    if( (mres->GPR[r2].rl & 0x00000001)==1 && (mres->GPR[r3].rl & 0x00000001)==1 ) bit32c=1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = mres->GPR[r2].rl + mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}   


int op_1f_00b_func( struct MACHINE_RESOURCE *mres , int mode ) /* mulhwux */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
#ifndef UNSUPPORTED_LONGLONGINT
    {
      int i ;
      unsigned int w0,w1,w2 ;
      unsigned int t0,t1,t2 ;
      unsigned int c1,c2 ;
      unsigned int msk ;
      w0=0 ; w1=0 ; w2=0 ;
      t0=0 ;
    
      t1=(mres->GPR[r2].rl&0x80000000)>>31 ;
      t2=(mres->GPR[r2].rl&0x7fffffff) ;
      msk=0x00000001 ;
      for( i=0 ; i<32 ; i++ ){
	if( (mres->GPR[r3].rl & msk)!=0 ){
	  c1=0 ; c2=0 ;
	  w2=w2+t2 ;
	  if( (w2 & 0x80000000)!=0 ){
	    w2&=0x7fffffff ;
	    c2++ ;
	  }
	  w1=w1+t1+c2 ;
	  if( (w1 & 0x80000000)!=0 ){
	    w1&=0x7fffffff ;
	    c1++ ;
	  }
	  w0=w0+t0+c1 ;
	}
	msk<<=1 ;
	t2<<=1 ;
	if( (t2 & 0x80000000)!=0 ){
	  t2&=0x7fffffff ;
	  t1<<=1 ; t1|=1 ;
	}else{
	  t1<<=1 ;
	}
	if( (t1 & 0x80000000)!=0 ){
	  t1&=0x7fffffff ;
	  t0<<=1 ; t0|=1 ;
	}else{
	  t0<<=1 ;
	}
      }
      mres->GPR[r1].rl = ((w0&3)<<30) | (w1>>1) ;
    }
#else
    {
      unsigned long long int a,b,r ;

      a=mres->GPR[r2].rl ;
      b=mres->GPR[r3].rl ;
      r=a*b ;
      mres->GPR[r1].rl=r>>32 ;
    }
#endif
    
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_013_func( struct MACHINE_RESOURCE *mres , int mode ) /* mfcr */
{
  unsigned int r1,r2,r3 ;
  int i ;
  
  r1    = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2    = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3    = (mres->inst & 0x0000f800)>>11 ; // rB rB

  if( DO_EXEC_DIS(mode) ){
    dis_print_r(r1) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2!=0 || r3!=0 ) return(INSTFORM_IS_INVALID) ;
    
    mres->GPR[r1].rl=0 ;
    for( i=0 ; i<8 ; i++ ){
      mres->GPR[r1].rl |= mres->FLGR.cr[i]>>(i*4) ;
    }
    mres->pc+=4 ;
  }

  return(0) ;
}
  
  
int op_1f_014_func( struct MACHINE_RESOURCE *mres , int mode ) /* lwarx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  int          pa ;
  
  r1    = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2    = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3    = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    fetchu4b(mres->GPR[r1].rl,ea) ;
    *mres->RSV  =1  ;
    ADTR(mres,&pa,ea) ;
    *mres->RSVAD=pa ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_017_func( struct MACHINE_RESOURCE *mres , int mode ) /* lwzx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1    = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2    = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3    = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchu4b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_1f_018_func( struct MACHINE_RESOURCE *mres , int mode ) /* slwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr =  mres->inst & 0x00000001 ;
 
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl<<(mres->GPR[r3].rl & 0x0000003f) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_01a_func( struct MACHINE_RESOURCE *mres , int mode ) /* cntlzw */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int chkbit ;
  int i,count ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r2,r1) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    for( i=0,chkbit=0x80000000,count=0 ; i<32 ; i++,chkbit>>=1 ){
      if( (mres->GPR[r1].rl & chkbit) == 0 ){
	count++ ;
      }else{
	break ;
      }
    }
    mres->GPR[r2].rl = count ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_01c_func( struct MACHINE_RESOURCE *mres , int mode ) /* andx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl & mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_1f_020_func( struct MACHINE_RESOURCE *mres , int mode )  /* cmpl */
{
  unsigned int r2,r3 ;
  unsigned int cr ;
  
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  cr = (mres->inst & 0x03800000)>>23 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_crrr(cr,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r2].rl == mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x20000000 ;
    else                                       mres->FLGR.cr[cr] &=~0x20000000 ;
    if( mres->GPR[r2].rl >  mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x40000000 ;
    else                                       mres->FLGR.cr[cr] &=~0x40000000 ;
    if( mres->GPR[r2].rl <  mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x80000000 ;
    else                                       mres->FLGR.cr[cr] &=~0x80000000 ;
    if( (mres->FLGR.xer & 0x80000000)!=0 )     mres->FLGR.cr[cr] |= 0x10000000 ;
    else                                       mres->FLGR.cr[cr] &=~0x10000000 ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_028_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr    !=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl =  ~mres->GPR[r2].rl + mres->GPR[r3].rl + 1;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_036_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcbst 取りあえずNOP */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_037_func( struct MACHINE_RESOURCE *mres , int mode )  /* lwzux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==r1 ) return( INSTFORM_IS_INVALID ) ;
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchu4b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_03c_func( struct MACHINE_RESOURCE *mres , int mode )  /* andcx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl & ~mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  return(0) ;
}


int op_1f_04b_func( struct MACHINE_RESOURCE *mres , int mode )  /* mulhwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
#ifndef UNSUPPORTED_LONGLONGINT
    {
      int i ;
      unsigned int w0,w1,w2 ;
      unsigned int t0,t1,t2 ;
      unsigned int c1,c2 ;
      unsigned int tmpa,tmpb ;
      unsigned int msk ;
      w0=0 ; w1=0 ; w2=0 ;
      if( (mres->GPR[r2].rl & 0x80000000)==0 ) tmpa=  mres->GPR[r2].rl ;
      else                                     tmpa=(~mres->GPR[r2].rl)+1 ;
      if( (mres->GPR[r3].rl & 0x80000000)==0 ) tmpb=  mres->GPR[r3].rl ;
      else                                     tmpb=(~mres->GPR[r3].rl)+1 ;
      t0=0 ;
      t1=(tmpa&0x80000000)>>31 ;
      t2=(tmpa&0x7fffffff) ;
      msk=0x00000001 ;
      for( i=0 ; i<32 ; i++ ){
	if( (tmpb & msk)!=0 ){
	  c1=0 ; c2=0 ;
	  w2=w2+t2 ;
	  if( (w2 & 0x80000000)!=0 ){
	    w2&=0x7fffffff ;
	    c2++ ;
	  }
	  w1=w1+t1+c2 ;
	  if( (w1 & 0x80000000)!=0 ){
	    w1&=0x7fffffff ;
	    c1++ ;
	  }
	  w0=w0+t0+c1 ;
	}
	msk<<=1 ;
	t2<<=1 ;
	if( (t2 & 0x80000000)!=0 ){
	  t2&=0x7fffffff ;
	  t1<<=1 ; t1|=1 ;
	}else{
	  t1<<=1 ;
	}
	if( (t1 & 0x80000000)!=0 ){
	  t1&=0x7fffffff ;
	  t0<<=1 ; t0|=1 ;
	}else{
	  t0<<=1 ;
	}
      }
      tmpa=mres->GPR[r2].rl & 0x80000000 ;
      tmpb=mres->GPR[r3].rl & 0x80000000 ;
      t0 = ((w0&3)<<30) | (w1>>1) ;
      if( (tmpa!=0 && tmpb==0) || (tmpa==0 && tmpb!=0) ){
	if( mres->GPR[r2].rl!=0 && mres->GPR[r3].rl!=0 ){
	  t0=(~t0) ;
	}
      }
      mres->GPR[r1].rl = t0 ;
    }
#else
    {
      long long int a,b,r ;

      a=(int)mres->GPR[r2].rl ;
      b=(int)mres->GPR[r3].rl ;
      r=a*b ;
      mres->GPR[r1].rl=r>>32 ;
    }
#endif
    
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
  
}


int op_1f_052_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtsrd */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/*ppcsim not implement*/\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_053_func( struct MACHINE_RESOURCE *mres , int mode )  /* mfmsr */
{
  unsigned int r1 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS

  if( DO_EXEC_DIS(mode) ){
    dis_print_r(r1) ;
  }

  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl = *mres->MSR ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_056_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcbf 取りあえずNOP */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }
  return(0) ;
}


int op_1f_057_func( struct MACHINE_RESOURCE *mres , int mode )  /* lbzx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchu1b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_068_func( struct MACHINE_RESOURCE *mres , int mode )  /* negx */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r2].rl==0x00000000 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = -mres->GPR[r2].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_072_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtsrdin */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_077_func( struct MACHINE_RESOURCE *mres , int mode )  /* lbzux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==r1 ) return( INSTFORM_IS_INVALID ) ;
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchu1b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_07c_func( struct MACHINE_RESOURCE *mres , int mode )  /* norx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = ~(mres->GPR[r1].rl | mres->GPR[r3].rl) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_088_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfex */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r3].rl + ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
    bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	      (mres->GPR[r3].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}   


int op_1f_08a_func( struct MACHINE_RESOURCE *mres , int mode )  /* addex */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r2].rl + mres->GPR[r3].rl + ((mres->FLGR.xer & 0x20000000)!=0);
    bit32c= (((mres->GPR[r2].rl&0x00000001)+
	      (mres->GPR[r3].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  
  
  
int op_1f_090_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtcrf */
{
  unsigned int r1 ;
  int i ;
  unsigned int crm,flag ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  crm = (mres->inst & 0x000ff000) ;
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%d,%%r%d\n",crm,r1) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    flag= 0x00080000 ;
    for( i=0 ; i<8 ; i++,flag=flag>>1 ){
      if( (crm & flag)!=0 ){
	mres->FLGR.cr[i] = (mres->GPR[r1].rl<<(i*4))&0xf0000000 ;
      }
    }
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_092_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtmsr */
{
  unsigned int r1 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_r(r1) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    *mres->MSR = mres->GPR[r1].rl ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_096_func( struct MACHINE_RESOURCE *mres , int mode )  /* stwcx. */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  int          pa ;
  unsigned int updt_cr ;

  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( updt_cr!=0 ){
      if( r2==0 ){
	ea=mres->GPR[r3].rl ;
      }else{
	ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
      }
      if( *mres->RSV==1 ){
	ADTR(mres,&pa,ea) ;
	if( *mres->RSVAD==pa ){
	  storeu4b(mres->GPR[r1].rl,ea) ;
	  mres->FLGR.cr[0] |= 0x20000000 ;
	}else{
	  // アドレス変換でアクセス可能であればストアできる
	  storeu4b(mres->GPR[r1].rl,ea) ;
	  mres->FLGR.cr[0] |= 0x20000000 ;
	}
	*mres->RSV=0 ;
      }else{
	mres->FLGR.cr[0] &= ~0x20000000 ;
      }
      mres->pc+=4 ;
      return(0) ;
    }else{
      return( INSTFORM_IS_INVALID ) ;
    }
  }
  return(0) ;
}


int op_1f_097_func( struct MACHINE_RESOURCE *mres , int mode )  /* stwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storeu4b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0b7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stwux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storeu4b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0c8_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfzex */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
    bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui0=tmpui1+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0ca_func( struct MACHINE_RESOURCE *mres , int mode )  /* addzex */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0);
    bit32c= (((mres->GPR[r2].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui0=tmpui1+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_0d2_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtsr */
{
  unsigned int r1,r2 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%r%d, %%sr%d\n",r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2 > 15 ) return(INSTFORM_IS_INVALID) ;
    *mres->SR[r2] = mres->GPR[r1].rl ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0d7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stbx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storeu1b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0e8_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfmex */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = 0xffffffff + ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
    bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	      1+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=0x7fffffff ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}   


int op_1f_0ea_func( struct MACHINE_RESOURCE *mres , int mode )  /* addmex */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r2].rl + 0xffffffff + ((mres->FLGR.xer & 0x20000000)!=0);
    bit32c= (((mres->GPR[r2].rl&0x00000001)+
	      1+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=0x7fffffff ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ;   //set Carry
    }else{
      mres->FLGR.xer &=~0x20000000 ;   //reset Carry
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0eb_func( struct MACHINE_RESOURCE *mres , int mode )  /* mullwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;

  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl = (long long)(mres->GPR[r2].rl * mres->GPR[r3].rl) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0f2_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtsrin */
{
  unsigned int r1,r3 ;
  
  r1  = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r3  = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rr(r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    *mres->SR[(mres->GPR[r3].rl>>28)] = mres->GPR[r1].rl ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_0f6_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcbtst 取りあえずNOP */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_0f7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stbux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storeu1b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_10a_func( struct MACHINE_RESOURCE *mres , int mode )  /* addx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl = mres->GPR[r2].rl + mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;

    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_116_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcbt */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_117_func( struct MACHINE_RESOURCE *mres , int mode )  /* lhzx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchu2b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_11c_func( struct MACHINE_RESOURCE *mres , int mode )  /* eqvx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = ~(mres->GPR[r1].rl ^ mres->GPR[r3].rl) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}
  

int op_1f_132_func( struct MACHINE_RESOURCE *mres , int mode )  /* tlbie */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_136_func( struct MACHINE_RESOURCE *mres , int mode )  /* eciwx */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_137_func( struct MACHINE_RESOURCE *mres , int mode )  /* lhzux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==r1 ) return( INSTFORM_IS_INVALID ) ;
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchu2b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_13c_func( struct MACHINE_RESOURCE *mres , int mode )  /* xorx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl ^ mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_153_func( struct MACHINE_RESOURCE *mres , int mode )  /* mfspr */
{
  unsigned int r1,r2,r3 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%r%d, %%spr%d\n",r1,r3*32+r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl = *mres->SPR[r3*32+r2] ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_157_func( struct MACHINE_RESOURCE *mres , int mode )  /* lhax */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchs2b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_172_func( struct MACHINE_RESOURCE *mres , int mode )  /* tlbia */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_173_func( struct MACHINE_RESOURCE *mres , int mode )  /* mftb */
{
  unsigned int r1,r2,r3 ;
  int tbr_num ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%r%d, %%tbr%d\n",r1,r3*32+r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    tbr_num=r3*32+r2 ;
    if(       tbr_num==268 ){
      mres->GPR[r1].rl = *mres->TBL ;
    }else if( tbr_num==269 ){
      mres->GPR[r1].rl = *mres->TBU ;
    }else{
      return( INSTFORM_IS_INVALID ) ;
    }
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_177_func( struct MACHINE_RESOURCE *mres , int mode )  /* lhaux */
{
  unsigned int r1,r2,r3 ;
  int          adrs_update ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  adrs_update = mres->inst & 0x00000040 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==r1 && adrs_update!=0 ) return( INSTFORM_IS_INVALID ) ;
    if( r2==0 ){
      if( adrs_update!=0 ){
	return( INSTFORM_IS_INVALID ) ;
      }
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchs2b(mres->GPR[r1].rl,ea) ;
    
    if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_197_func( struct MACHINE_RESOURCE *mres , int mode )  /* sthx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storeu2b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_19c_func( struct MACHINE_RESOURCE *mres , int mode )  /* orcx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl | ~mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_1b6_func( struct MACHINE_RESOURCE *mres , int mode )  /* ecowx */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}



int op_1f_1b7_func( struct MACHINE_RESOURCE *mres , int mode )  /* sthux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storeu2b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_1bc_func( struct MACHINE_RESOURCE *mres , int mode )  /* orx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl | mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_1cb_func( struct MACHINE_RESOURCE *mres , int mode )  /* divwux */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r3].rl==0 ){
      if( excp_stat.e2f00.stat == DISABLE ){ //ppcsimだけの特別処置
	mres->GPR[r1].rl=0 ;
	if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
	mres->pc+=4 ;
	return(0) ;
      }else{
	return(DIVIDED_BY_ZERO) ;
      }
    }
    
    mres->GPR[r1].rl = mres->GPR[r2].rl / mres->GPR[r3].rl ;
    
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_1d3_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtspr */
{
  unsigned int r1,r2,r3 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%r%d, %%spr%d\n",r1,r3*32+r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    *mres->SPR[r3*32+r2] = mres->GPR[r1].rl ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_1d6_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcbi */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}  


int op_1f_1dc_func( struct MACHINE_RESOURCE *mres , int mode )  /* nandx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r2,r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = ~(mres->GPR[r1].rl & mres->GPR[r3].rl) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_1eb_func( struct MACHINE_RESOURCE *mres , int mode )  /* divwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r3].rl==0 ){
      if( excp_stat.e2f00.stat == DISABLE ){ //ppcsimだけの特別処置
	mres->GPR[r1].rl=0 ;
	if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
	mres->pc+=4 ;
	return(0) ;
      }else{
	return(DIVIDED_BY_ZERO) ;
      }
    }
    
    mres->GPR[r1].rl = (int)mres->GPR[r2].rl / (int)mres->GPR[r3].rl ;
    
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_200_func( struct MACHINE_RESOURCE *mres , int mode )  /* mcrxr */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_208_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfco */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	    (mres->GPR[r3].rl & 0x00000001)+1)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ~mres->GPR[r2].rl + mres->GPR[r3].rl + 1  ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_20a_func( struct MACHINE_RESOURCE *mres , int mode )  /* addcx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    bit32c=0 ;
    if( (mres->GPR[r2].rl & 0x00000001)==1 && (mres->GPR[r3].rl & 0x00000001)==1 ) bit32c=1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = mres->GPR[r2].rl + mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_215_func( struct MACHINE_RESOURCE *mres , int mode )  /* lswx */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_216_func( struct MACHINE_RESOURCE *mres , int mode )  /* lwbrx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ) ea=mres->GPR[r3].rl ;
    else        ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    fetchu4b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r1].rl= (mres->GPR[r1].rl & 0xff000000)>>24 | (mres->GPR[r1].rl & 0x00ff0000)>>8 | \
                      (mres->GPR[r1].rl & 0x000000ff)<<24 | (mres->GPR[r1].rl & 0x0000ff00)<<8 ;
    mres->pc+=4 ;
  }
  return(0) ;
}


int op_1f_217_func( struct MACHINE_RESOURCE *mres , int mode )  /* lfsx */
{
  unsigned int r1,r2,r3 ;
  int          adrs_update ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  adrs_update = mres->inst & 0x00000040 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==r1 && adrs_update!=0 ) return( INSTFORM_IS_INVALID ) ;
    if( r2==0 ){
      if( adrs_update!=0 ){
	return( INSTFORM_IS_INVALID ) ;
      }
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchf4b(mres->FPR[r1].f,ea) ;
    
    if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_218_func( struct MACHINE_RESOURCE *mres , int mode )  /* srwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl>>(mres->GPR[r3].rl & 0x0000003f) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_228_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	    (mres->GPR[r3].rl & 0x00000001)+1)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl =  ~mres->GPR[r2].rl + mres->GPR[r3].rl + 1;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_236_func( struct MACHINE_RESOURCE *mres , int mode )  /* tlbsync */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_237_func( struct MACHINE_RESOURCE *mres , int mode )  /* lfsux */
{
  unsigned int r1,r2,r3 ;
  int          adrs_update ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  adrs_update = mres->inst & 0x00000040 ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      if( adrs_update!=0 ) {
	return( INSTFORM_IS_INVALID ) ;
      }
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchf4b(mres->FPR[r1].f,ea) ;
    
    if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_253_func( struct MACHINE_RESOURCE *mres , int mode )  /* mfsr */
{
  unsigned int r1,r2 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%r%d, %%sr%d\n",r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2 > 15 ) return(INSTFORM_IS_INVALID) ;
    mres->GPR[r1].rl = *mres->SR[r2] ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_255_func( struct MACHINE_RESOURCE *mres , int mode )  /* lswi */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ) ea=0 ;
    else        ea=mres->GPR[r2].rl ;
    {
      int i,n ;
      unsigned int ui ;
      if( r3==0 ) n=32 ;
      else        n=r3 ;
      for( i=0 ; i<n ; i++ ){
	if( (i%4)==0 ) mres->GPR[((i/4)+r1)%32].rl=0 ;
	fetchu1b( ui, (ea+i) ) ;
	mres->GPR[((i/4)+r1)%32].rl = mres->GPR[((i/4)+r1)%32].rl | (ui << ((3-(i%4))*8)) ;
      }
    }
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_256_func( struct MACHINE_RESOURCE *mres , int mode )  /* sync とりあえずNOP */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_257_func( struct MACHINE_RESOURCE *mres , int mode )  /* lfdx */
{
  unsigned int r1,r2,r3 ;
  int          adrs_update ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  adrs_update = mres->inst & 0x00000040 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      if( adrs_update!=0 ) {
	return( INSTFORM_IS_INVALID ) ;
      }
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchd8b(mres->FPR[r1].f,ea) ;
    
    if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_268_func( struct MACHINE_RESOURCE *mres , int mode )  /* negx */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r2].rl==0x00000000 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = -mres->GPR[r2].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_277_func( struct MACHINE_RESOURCE *mres , int mode )  /* lfdux */
{
  unsigned int r1,r2,r3 ;
  int          adrs_update ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  adrs_update = mres->inst & 0x00000040 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      if( adrs_update!=0 ) {
	return( INSTFORM_IS_INVALID ) ;
      }
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    fetchd8b(mres->FPR[r1].f,ea) ;
    
    if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_288_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfex */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r3].rl + ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
    bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	      (mres->GPR[r3].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}   


int op_1f_28a_func( struct MACHINE_RESOURCE *mres , int mode )  /* addex */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r2].rl + mres->GPR[r3].rl + ((mres->FLGR.xer & 0x20000000)!=0);
    bit32c= (((mres->GPR[r2].rl&0x00000001)+
	      (mres->GPR[r3].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  
  
  
int op_1f_293_func( struct MACHINE_RESOURCE *mres , int mode )  /* mfsrin */
{
  unsigned int r1,r3 ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rr(r1,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl = *mres->SR[mres->GPR[r3].rl>>28] ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_295_func( struct MACHINE_RESOURCE *mres , int mode )  /* stswx */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_296_func( struct MACHINE_RESOURCE *mres , int mode )  /* stwbrx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  unsigned int dt ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }

    dt=((mres->GPR[r1].rl & 0xff000000)>>24) ; storeu1b(dt,(ea+3)) ;
    dt=((mres->GPR[r1].rl & 0x00ff0000)>>16) ; storeu1b(dt,(ea+2)) ;
    dt=((mres->GPR[r1].rl & 0x0000ff00)>> 8) ; storeu1b(dt,(ea+1)) ;
    dt=((mres->GPR[r1].rl & 0x000000ff)    ) ; storeu1b(dt,(ea+0)) ;

    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_297_func( struct MACHINE_RESOURCE *mres , int mode )  /* stfsx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storef4b(mres->FPR[r1].f,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2b7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stfsux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    storef4b(mres->FPR[r1].f,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2c8_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfzex */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
    bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui0=tmpui1+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2ca_func( struct MACHINE_RESOURCE *mres , int mode )  /* addzex */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0);
    bit32c= (((mres->GPR[r2].rl&0x00000001)+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui0=tmpui1+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}  


int op_1f_2d5_func( struct MACHINE_RESOURCE *mres , int mode )  /* stswi */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ) ea=0 ;
    else        ea=mres->GPR[r2].rl ;
    {
      int i,n ;
      unsigned int ui ;
      if( r3==0 ) n=32 ;
      else        n=r3 ;
      for( i=0 ; i<n ; i++ ){
	ui = (mres->GPR[((i/4)+r1)%32].rl & (0xff000000 >> (((i%4))*8))) >> ((3-(i%4))*8) ;
	storeu1b( ui, (ea+i) ) ;
      }
    }
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2d7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stfdx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    stored8b(mres->FPR[r1].f,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2e8_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfmeox */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = 0xffffffff + ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
    bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	      1+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=0x7fffffff ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}   


int op_1f_2ea_func( struct MACHINE_RESOURCE *mres , int mode )  /* addmex */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  unsigned int ans ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr     = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r1,r2) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    ans = mres->GPR[r2].rl + 0xffffffff + ((mres->FLGR.xer & 0x20000000)!=0);
    bit32c= (((mres->GPR[r2].rl&0x00000001)+
	      1+
	      ((mres->FLGR.xer&0x20000000)!=0)
	      )&0x00000002)>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=0x7fffffff ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      mres->FLGR.xer |= 0x20000000 ; //set Carry
      mres->FLGR.xer |= 0x80000000 ; //set SO
      mres->FLGR.xer |= 0x40000000 ; //set OV
    }else{
      mres->FLGR.xer &=~0x20000000 ; //reset Carry
      mres->FLGR.xer &=~0x40000000 ; //reset OV
    }
    mres->GPR[r1].rl = ans ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2eb_func( struct MACHINE_RESOURCE *mres , int mode )  /* mullwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
   dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl = (long long)(mres->GPR[r2].rl * mres->GPR[r3].rl) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_2f6_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcba */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_2f7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stfdux */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    stored8b(mres->FPR[r1].f,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_30a_func( struct MACHINE_RESOURCE *mres , int mode )  /* addx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr, updt_ovflow ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr     = mres->inst & 0x00000001 ;
  updt_ovflow = mres->inst & 0x00000400 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    bit32c=0 ;
    if( (mres->GPR[r2].rl & 0x00000001)==1 && (mres->GPR[r3].rl & 0x00000001)==1 ) bit32c=1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=mres->GPR[r3].rl>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ){
      if( updt_ovflow != 0 ){
	mres->FLGR.xer |= 0x80000000 ; //set SO
	mres->FLGR.xer |= 0x40000000 ; //set OV
      }
    }else{
      if( updt_ovflow != 0 ){
	mres->FLGR.xer &=~0x40000000 ; //reset OV
      }
    }
    mres->GPR[r1].rl = mres->GPR[r2].rl + mres->GPR[r3].rl ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_316_func( struct MACHINE_RESOURCE *mres , int mode )  /* lhbrx */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* not implement on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  return(0) ;
}


int op_1f_318_func( struct MACHINE_RESOURCE *mres , int mode )  /* srawx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  unsigned int flg ;
  int i,sh ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    sh=mres->GPR[r3].rl & 0x0000003f ;
    mres->FLGR.xer &=~0x20000000 ;     //reset Carry
    if( (mres->GPR[r1].rl & 0x80000000)!=0 && sh!=0 ){
      for( i=0,flg=0x00000001 ; i<sh ; i++,flg+=flg ){
	if( (mres->GPR[r1].rl & flg)!=0 ){
	  mres->FLGR.xer |= 0x20000000 ;     //set Carry
	  break ;
	}
      }
    }
    mres->GPR[r2].rl = (int)mres->GPR[r1].rl>>(mres->GPR[r3].rl & 0x0000003f) ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_338_func( struct MACHINE_RESOURCE *mres , int mode )  /* srawix */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    unsigned int flg ;
    int i ;
    mres->FLGR.xer &=~0x20000000 ;     //reset Carry
    if( (mres->GPR[r1].rl & 0x80000000)!=0 && r3!=0 ){
      for( i=0,flg=0x00000001 ; i<r3 ; i++,flg+=flg ){
	if( (mres->GPR[r1].rl & flg)!=0 ){
	  mres->FLGR.xer |= 0x20000000 ;     //set Carry
	  break ;
	}
      }
    }
    mres->GPR[r2].rl = (int)mres->GPR[r1].rl>>r3 ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_356_func( struct MACHINE_RESOURCE *mres , int mode )  /* eieio */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}

  
int op_1f_396_func( struct MACHINE_RESOURCE *mres , int mode )  /* sthbrx */
{
  unsigned int r1,r2,r3 ;
  unsigned int ea ;
  unsigned int dt ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    dt=((mres->GPR[r1].rl & 0x0000ff00)>>8) ; storeu1b(dt,(ea+1)) ;
    dt=((mres->GPR[r1].rl & 0x000000ff)   ) ; storeu1b(dt,(ea  )) ;

    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_39a_func( struct MACHINE_RESOURCE *mres , int mode )  /* extshx */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r2,r1) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl & 0x0000ffff ;
    if( (mres->GPR[r2].rl & 0x00008000)!=0 ) mres->GPR[r2].rl = mres->GPR[r2].rl | 0xffff0000 ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_3ba_func( struct MACHINE_RESOURCE *mres , int mode )  /* extsbx */
{
  unsigned int r1,r2 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rr(r2,r1) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl & 0x000000ff ;
    if( (mres->GPR[r2].rl & 0x00000080)!=0 ) mres->GPR[r2].rl = mres->GPR[r2].rl | 0xffffff00 ;
    if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_3cb_func( struct MACHINE_RESOURCE *mres , int mode )  /* divwux */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r3].rl==0 ){
      if( excp_stat.e2f00.stat == DISABLE ){ //ppcsimだけの特別処置
	mres->GPR[r1].rl=0 ;
	if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
	mres->pc+=4 ;
	return(0) ;
      }else{
	return(DIVIDED_BY_ZERO) ;
      }
    }
    
    mres->GPR[r1].rl = (int)mres->GPR[r2].rl / (int)mres->GPR[r3].rl ;
    
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_3d6_func( struct MACHINE_RESOURCE *mres , int mode )  /* icbi */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t/* same NOP on ppcsim */\n") ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_1f_3d7_func( struct MACHINE_RESOURCE *mres , int mode )  /* stfiwx */
{
  unsigned int r1,r2,r3 ;
  int          adrs_update ;
  unsigned int ea ;
  
  r1 = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2 = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3 = (mres->inst & 0x0000f800)>>11 ; // rB rB
  
  adrs_update = mres->inst & 0x00000040 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      if( adrs_update!=0 ) {
	return( INSTFORM_IS_INVALID ) ;
      }
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    
    {
      unsigned long long int *cast_ll ;
      unsigned int uint_tmp ;
      
      cast_ll = (unsigned long long int *)&mres->FPR[r1].f ;
      uint_tmp = (unsigned int)(*cast_ll & 0xffffffff) ;
      storeu4b(uint_tmp,ea) ;
    }
    
    if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_3eb_func( struct MACHINE_RESOURCE *mres , int mode )  /* divwx */
{
  unsigned int r1,r2,r3 ;
  unsigned int updt_cr ;
  
  r1      = (mres->inst & 0x03e00000)>>21 ; // rD rS
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB
  updt_cr = mres->inst & 0x00000001 ;
  
  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ) SYSMSG(".") ;
    dis_print_rrr(r1,r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r3].rl==0 ){
      if( excp_stat.e2f00.stat == DISABLE ){ //ppcsimだけの特別処置
	mres->GPR[r1].rl=0 ;
	if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
	mres->pc+=4 ;
	return(0) ;
      }else{
	return(DIVIDED_BY_ZERO) ;
      }
    }
    
    mres->GPR[r1].rl = (int)mres->GPR[r2].rl / (int)mres->GPR[r3].rl ;
    
    if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_3f6_func( struct MACHINE_RESOURCE *mres , int mode )  /* dcbz */
{
  unsigned int r2,r3 ;
  unsigned int ea ;
  unsigned int zero ;
  int i ;
  
  r2      = (mres->inst & 0x001f0000)>>16 ; // rA rA
  r3      = (mres->inst & 0x0000f800)>>11 ; // rB rB

  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%r%d,%%r%d\n",r2,r3) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    zero=0 ;
    if( r2==0 ){
      ea=mres->GPR[r3].rl ;
    }else{
      ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
    }
    ea=(ea/0x20)*0x20 ;
    for( i=0 ; i<8 ; i++ ){
      storeu4b(zero,ea+i*4) ;
    }
    
    mres->pc+=4 ;
  }

  return(0) ;
}

