/**********************************************************************
  システムコールエミュレーションテーブル
  $Id: op_scemu.h 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
/*
   3 : extern _syscall3(int,read,int,fd,char *,buf,off_t,count)
   4 : extern _syscall3(int,write,int,fd,const char *,buf,off_t,count)
   5 : extern _syscall3(int,open,const char *,file,int,flag,int,mode)
   6 : extern _syscall1(int,close,int,fd)
   9 : extern _syscall2(int,link,const char *,src,const char *,dst)
  10 : extern _syscall1(int,unlink,const char *,path)
  11 : extern _syscall3(int,execve,const char *,file,char **,argv,char **,envp)
  12 : extern _syscall1(int,chdir,const char *,path)
  19 : extern _syscall3(off_t,lseek,int,fd,off_t,offset,int,count)
  20 : extern _syscall0(pid_t,getpid)
  23 : extern _syscall1(int,setuid,uid_t,uid)
  33 : extern _syscall2(int,access,const char *,path,int,amode)
  37 : extern _syscall2(int,kill,pid_t,pid,int,sig)
  38 : extern _syscall2(int,rename,const char *,old,const char *,new)
  39 : extern _syscall2(int,mkdir,const char *,path, mode_t,mode)
  40 : extern _syscall1(int,rmdir,const char *,path)
  41 : extern _syscall1(int,dup,int,fd)
  46 : extern _syscall1(int,setgid,gid_t,gid)
  47 : extern _syscall0(gid_t,getgid)
  63 : extern _syscall2(int,dup2,int,fd1,int,fd2)
  83 : extern _syscall2(int,symlink,const char *,src,const char *,dst)
  85 : extern _syscall3(int,readlink,const char*,linkpath,char *,namebuf,int,buflen)
 181 : extern _syscall3(int,chown,const char *,path,uid_t,owner,gid_t,group)
 182 : extern _syscall2(int,getcwd,char *,buff,int,size)
 200 : extern _syscall1(int,isatty,int,fd)
*/

/*
 * Cygwin DIR ptr <-> PPCLIB DIR ptr convert table
 */
#ifdef SUPPORT_SYSTEMCALL_EMULATION
#define DIR_ENTRY_MAX 256
struct DIR_LIST{
  unsigned int ppc_mem_ptr ;
  DIR          *cygwin_DIR ;
} ;
struct DIR_LIST dir_list[DIR_ENTRY_MAX] ;
#endif

enum SC_EMU_MODE {
  NEWLIBPOWERX,
  LINUXPPC
} ;
    
enum SC_EMU_MODE sc_emu_mode ;

int init_mman(struct MACHINE_RESOURCE *mres) ;
int release_mman(struct MACHINE_RESOURCE *mres) ;
int dup_mman(struct MACHINE_RESOURCE *mres_s, struct MACHINE_RESOURCE *mres_d) ;
int sim_mmap(struct MACHINE_RESOURCE *mres,int _adr,int _len,int _prot,int _flags,int _fd,int _off) ;
int sim_munmap(struct MACHINE_RESOURCE *mres,int _adr,int _len) ;
int sim_munmap_all(struct MACHINE_RESOURCE *mres) ;
int set_phyfd( struct MACHINE_RESOURCE *mres, int fd ) ;
int set_phyfd2( struct MACHINE_RESOURCE *mres, int fd, int pfd) ;
int get_phyfd( struct MACHINE_RESOURCE *mres, int fd ) ;
int close_fd( struct MACHINE_RESOURCE *mres, int fd ) ;
