/************************************************************************
  PPCSIMヘッダ
  $Id: ppcsim.h 77 2011-11-25 15:16:46Z tane $
************************************************************************/

/************************************************************************
  トレースヒストリ関連
************************************************************************/

struct TRACE_BUF_STRUCT{
  int           pid ;
  unsigned int  pc ;
  unsigned int  inst ;
} ;
struct TRACE_STRUCT{
  int ptr   ;
  int size  ;
  struct TRACE_BUF_STRUCT *buf ;
} ;

struct TRACE_STRUCT trace ;

long long int iexe_count  ;

#define	DEFAULT_TRACE_SIZE 256

/************************************************************************
  Passポイント
************************************************************************/
struct PPMSG_STAT{
  int msg_type  ;
  int print_type ;
} ;

struct PPMSG_STAT ppmsg_stat ;

#define PP_DUMP_PC   0
#define PP_DUMP_GPR  1
#define PP_DUMP_ALL  2
#define PP_DUMP_GPRn 3
#define PP_DUMP_FPRn 4
#define PP_DUMP_SPRn 5
#define PP_DUMP_TR   6

/************************************************************************
  実行モード
************************************************************************/
/*                                     0x00_00_00_00 */
/*                                              | || */
/*                                              | || */
/*                                              | || */
#define GO_EXEC_MODE    0x0100 /*---------------+ || */
#define GO_STEP_MODE    0x0010 /*-----------------+| */
#define GO_ALL_DUMP     0x0004 /*------+-----------+ */
#define GO_GPR_DUMP     0x0002 /*------+             */
#define GO_PC_DUMP      0x0001 /*------+             */

/***********************************************************************/
int	verbose ;
int	truss_stat ;

struct TRACE_STAT{
  int msg_type  ;
  int print_type ;
} ;

struct TRACE_STAT trace_stat ;

#define TRACE_OFF  0x0
#define TRACE_PC   0x1
#define TRACE_GRP  0x2
#define TRACE_ALL  0x3

/************************************************************************
  シミュレーションメッセージログ
************************************************************************/
char	*simlog  ;
FILE	*simmsgfp ;
#define	DEFAULT_SIMMSG_OUT stderr

#ifdef DEBUG
#define DEBUGMSG(fmt,...)   fprintf(simmsgfp, "Debug(%s:%d@%s):" fmt,__FILE__,__LINE__, __func__, ##__VA_ARGS__)
#else
#define DEBUGMSG(fmt,...)
#endif

#define SYSMSG(fmt,...)    fprintf(simmsgfp,fmt,##__VA_ARGS__)
#define SYSMSGLL(v,l)  printll(simmsgfp,v,l)
#define SYSMSGLLH(v,l) printllh(simmsgfp,v,l)

#define SYSERR(fmt,...)   fprintf(stderr,fmt,##__VA_ARGS__)

/************************************************************************
  シグナルハンドル
************************************************************************/
int  sig_int ;
void init_sighandl_ppcsim() ;
void set_sighandl_ppcsim() ;
void sighandl_ppcsim(int) ;

