/**********************************************************************
  プロセスの終了(マシンリソースの解放)
  $Id: remove_proc.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_scemu.h"

int	remove_proc( struct PROCESS_LIST *proc_list )
{
  int i ;
  int id ;

  id = proc_list->cur_id ;
  for( i=0 ; i<MEM_SEGMENT_NUM ; i++ ){
    if( proc_list->proc[id].mem_size[i]!=0 &&
	proc_list->proc[id].mem_attr[i]!=MEM_ATTR_SHARED ){
      free(proc_list->proc[id].mem[i]) ;
      proc_list->proc[id].mem[i]     = NULL ;
      proc_list->proc[id].mem_size[i]= 0 ;
    }
  }
  release_mman( &proc_list->proc[id] ) ;
  for( i=0 ; i<MAX_OPEN_FD ; i++ ){
    close_fd(&proc_list->proc[id], i) ;
  }
  proc_list->cur_id-- ;
  return(NORMAL_EXIT) ;
}
