/**********************************************************************
  ppcsim script run command
  $Id: run_cmd.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int  run_parse_opt(struct GETOPT_ARG *args) ;
void run_print_help() ;

int run_cmd( struct GETOPT_ARG *args , int mode )
{
  int i ;
  int ret ;
  
  ret=run_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  if( XGETOPT_REFARGP(args,1)==NULL ){
    SYSMSG("Not specified ppcsim script.\n") ;
    return( NORMAL_EXIT ) ;
  }

  for( i=1 ; i<XGETOPT_REFAGCP(args) ; i++ ){
    cmd_exec( XGETOPT_REFARGP(args,i) ) ;
  }
  
  return(NORMAL_EXIT) ;
}


int run_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      run_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void run_print_help()
{
  SYSERR(
	 "Running external ppcsim script\n"
	 "Usage: run files ...\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     file で指定されたppcsim scriptを実行します。\n"
	 ) ;
}
