/**********************************************************************
  シミュレーションステータス設定＆表示
  $Id: sim_cmd.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

#define NO_OPERATION -1

int  sim_parse_opt(struct GETOPT_ARG *args) ;
void sim_print_help() ;

int sim_cmd( struct GETOPT_ARG *args , int mode )
{
  int flag ;
  int all_on ; 
  int ret ;
  
  ret=sim_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  flag=NO_OPERATION ;
  if( XGETOPT_REFAGCP(args)==3 ){
    if(      strcmp(XGETOPT_REFARGP(args,2),"e")==0 ) flag=ENABLE  ;
    else if( strcmp(XGETOPT_REFARGP(args,2),"d")==0 ) flag=DISABLE ;
    else                                              flag=NO_OPERATION ;
    
    if( strcmp(XGETOPT_REFARGP(args,1),"all")==0 ) all_on=YES ;
    else                                           all_on=NO  ;
    
    if( exatoi(XGETOPT_REFARGP(args,1))==0x100 || all_on==YES ){
      excp_stat.e0100.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x200 || all_on==YES ){
      excp_stat.e0200.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x300 || all_on==YES ){
      excp_stat.e0300.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x400 || all_on==YES ){
      excp_stat.e0400.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x500 || all_on==YES ){
      excp_stat.e0500.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x600 || all_on==YES ){
      excp_stat.e0600.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x700 || all_on==YES ){
      excp_stat.e0700.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x800 || all_on==YES ){
      excp_stat.e0800.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x900 || all_on==YES ){
      excp_stat.e0900.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0xa00 || all_on==YES ){
      excp_stat.e0a00.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0xc00 || all_on==YES ){
      excp_stat.e0c00.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0xd00 || all_on==YES ){
      excp_stat.e0d00.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0xe00 || all_on==YES ){
      excp_stat.e0e00.stat=flag ;
    }
    if( exatoi(XGETOPT_REFARGP(args,1))==0x2f00 || all_on==YES ){
      excp_stat.e2f00.stat=flag ;
    }
  }else{
    print_simstat() ;
  }
  return(NORMAL_EXIT) ;
}


int sim_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      sim_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void sim_print_help()
{
  SYSERR(
	 "set exception simlate status\n"
	 "Usage: sim [type [e|d|u]]\n"
	 " type\n"
	 "   vect : exception vector[ex. 0x300]\n"
	 "   all  : all exception vector\n"
	 " cmd\n"
	 "   e  : enable Hardware exception\n"
	 "   d  : disable Hardware exception(print error message)\n"
	 "   u  : disable Hardware exception(not print error message)\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     CPU例外シミュレーションステータスを設定します。状態をENABLEにすると、\n"
	 "    例外シミュレーションが有効になります。DISABLE状態では例外が発生すると\n"
	 "    メッセージを出力してシミュレーション実行を停止します。\n"
	 ) ;
}
