/**********************************************************************
  簡易IOデバイス
  $Id: sim_io.c 77 2011-11-25 15:16:46Z tane $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int sim_io( struct MACHINE_RESOURCE *mres )
{
  int ret_code ;
  int i ;
  
#ifdef SUPPORT_GRAPHIC_DEVICE
  if( GdevBuf.c>=GdevBuf.n ) SyncGdevDraw( mres ) ;
#endif

  ret_code=NORMAL_EXIT ;

  if( (__pa_for_exception & 0x80000000) != 0 ){
    for( i=0 ; i<dev_list.num ; i++ ){
      if( dev_list.dev[i].ad_top <= __pa_for_exception &&
	  __pa_for_exception <= dev_list.dev[i].ad_bot ){
	ret_code= (dev_list.dev[i].func)( __pa_for_exception, mres ) ;
	break ;
      }
    }
  }
  dev_pic_prio_int() ;
  
  return( ret_code ) ;
}


#define entry_dev(f,i,t,b) {\
  if( dev_list.num==MAX_DEV_NUM ){\
    SYSERR("Fail initialize IO device\n") ; \
    return(-1) ; \
  }\
  dev_list.dev[dev_list.num].func=f ;\
  dev_list.dev[dev_list.num].inifunc=i ;\
  dev_list.dev[dev_list.num].ad_top=(t) ;\
  dev_list.dev[dev_list.num].ad_bot=(b) ;\
  dev_list.num++ ;\
  }



int init_sim_io( struct MACHINE_RESOURCE *mres )
{
  int i ;

  dev_list.num=0 ;

#ifdef SUPPORT_GRAPHIC_DEVICE
  entry_dev( dev_vram   , dev_vram_init   , (GRAPHIC_VRAM_SYNC+3), (GRAPHIC_VRAM_SYNC+3) ) ;
#endif
  entry_dev( dev_pic    , dev_pic_init    , (PIC_MASTER_PORT0)   , (PIC_MASTER_PORT1)    ) ;
  entry_dev( dev_pic    , dev_pic_init    , (PIC_SLAVE_PORT0)    , (PIC_SLAVE_PORT1)     ) ;
  entry_dev( dev_clock  , dev_clock_init  , (CLOCK_READ_CMD)     , (CLOCK_READ_CMD+3)    ) ;
  entry_dev( dev_disk   , dev_disk_init   , (DISK_CMD)           , (DISK_CMD+3)          ) ;
  entry_dev( dev_floppy , dev_floppy_init , (FDC_PORT_TOP)       , (FDC_PORT_BOT)        ) ;
  entry_dev( dev_console, dev_console_init, (CONSOLE_OUT_CMD)    , (CONSOLE_OUT_CMD+3)   ) ;
  entry_dev( dev_serial , dev_serial_init , (SERIAL_DATA_PORT0)  , (SERIAL_SCR_PORT0)    ) ;
  
  for( i=0 ; i<dev_list.num ; i++ ){
    (dev_list.dev[i].inifunc)( mres ) ;
  }

  return( NORMAL_EXIT ) ;
}

