/**********************************************************************
  string buffer function
  $Id: strbuf.h 77 2011-11-25 15:16:46Z tane $
**********************************************************************/

struct STRELM {
  char          *str ;
  struct STRELM *prev ;
  struct STRELM *next ;
} ;

struct STRBUF {
  struct STRELM *elm ;
  int size ;
  int ptr ;
} ;

struct STRBUF* STR_alloc() ;
int            STR_free( struct STRBUF *sbp ) ;
char*          STR_addlist( struct STRBUF *sbp, char *str ) ;
char*          STR_addtoplist( struct STRBUF *sbp, char *str ) ;
int            STR_dellist( struct STRBUF *sbp, int n ) ;
char*          STR_refstr( struct STRBUF *sbp, int n ) ;
char*          STR_replace( struct STRBUF *sbp, int n, char *str ) ;
int            STR_buflen( struct STRBUF *sbp ) ;

/*********************************************************************
  仕様

  STR_alloc()
    ストリングバッファを割り当てます
    戻り値 : ストリングバッファへのポインタを返します。
             失敗時はNULLを返します。

  STR_addlist(sbp,"string")
    文字列をストリングバッファに追加します。
    戻り値 : 失敗時はNULLを返します。

  STR_dellist(sbp,n) ;
    n番目のリストを削除します。
    戻り値 : 失敗時は -1 を返します。

  STR_replace(sbp,n,"string") ;
    n版目のリストの文字列を指定の文字列に置き換えます。
    置き換えに失敗しても元の文字列は保存されます。
    戻り値 : 文字列へのポインタを返します。
             置き換えに失敗した場合はNULLを返します。

  STR_refstr(sbp,n) ;
    n版目のリストの文字列を参照します。
    戻り値 : 文字列へのポインタを返します。
             リストが存在しない場合はNULLを返します。

  STR_buflen(sbp) ;
    ストリングバッファに保持されているのリストの数を返します。
    戻り値 : ストリングバッファのリスト数。
             無効なsbpを指定すると-1を返します。

  STR_free(sbp) ;
    ストリングバッファを開放します。
    戻り値 : 成功すれば0を返します。
             無効なsbpを指定すると-1を返します。

*********************************************************************/
